﻿601,100
602,"sys_generic_subset_creator"
562,"NULL"
586,
585,
564,
565,"aaZX>1jo7ZJ4DJUZHS?E]^\mu6Tc^m19;Rl1m^x6`qMF86d_@M\zN_hM_@maFiPiMYZ@G6Edw7whdwKi^DDW_ww_H]ZDZCRWkD<dlNyTKhDzEUhDZqUr?nn\XvQkl;vDJarOOjnarGlaT<WOFS>OalLOB@4d8g<z<BKbgByE]bG\iD1ijTKZu@w7c]g]nAnLfy<^3Ll5"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,","
588,"."
589,
568,""""
570,
571,
569,0
592,0
599,1000
560,14
pBasis
pDimension
pAttrName
pAttrSValue
pAttrNHighValue
pAttrNLowValue
pLevel
pParent
pSubName
pOverwrite
pElement
pSubsetType
pAlias
pAliasName
561,14
2
2
2
2
1
1
1
2
2
2
2
2
2
2
590,14
pBasis,""
pDimension,""
pAttrName,""
pAttrSValue,""
pAttrNHighValue,0
pAttrNLowValue,0
pLevel,0
pParent,""
pSubName,""
pOverwrite,"No"
pElement,""
pSubsetType,""
pAlias,""
pAliasName,""
637,14
pBasis,See Documentation in Prolog
pDimension,Dimension Name
pAttrName,Attribute Name
pAttrSValue,Attribute String Value
pAttrNHighValue,Attribut High Num Value
pAttrNLowValue,Attribute Low Num Value
pLevel,Level Filter
pParent,Parent
pSubName,Subset NameSubset Name
pOverwrite,Overwrite Yes or No
pElement,Leaf Element to Add
pSubsetType,'Expand' or 'Level0'
pAlias,Include Alias Yes / No
pAliasName,If pAlias = Yes then Alias Name
577,0
578,0
579,0
580,0
581,0
582,0
931,1

572,221

#****Begin: Generated Statements***
#****End: Generated Statements****

###########DOCUMENTATION#############
#Author: LBotha / JPorter
#Purpose: Generic subset creator.  Use to create / update subsets that are "Dynamic".
#  Real dynamic subsets are created by MDX rules and are very powerful, however should not be used as sources
#  within TI processes - they will drastically slow processes down.  This will update/create a subset for a process
#  without relying on dynamic process sets; currently ATTRS and ATTRN bases only add level 0 elements, generally
#  this should be all that is necessary for a source in a process - level support added for other cases.
#Parameters:
#  pBasis - Input 'ATTRS' for subsets based on a string attribute, 'ATTRN' for subsets based on a numeric attribute,
#               or 'LEVEL' for processes based on a level, 'LEAF' to add a single element.
#  pDimension - Dimension name from which to create the subset
#  pAttrName - Attribute name to filter on for ATTRS and ATTRN type subsets
#  pAttrSValue - Attribute value to filter on for ATTRS type subsets
#  pAttrNHighValue - Highest attribute value to filter on for ATTRN type subsets
#  pAttrNLowValue - Lowest attribut value to filter on for ATTRN type subsets
#  pLevel - Dimension level for LEVEL type subsets
#  pParent - Parent element within dimension to start at
#  pSubName - Subset name for output
#  pOverwrite - If Yes, delete elements out of subset and start over, if no add to subset (if it exists)
#  pElement - Element to add for LEAF type additions
#  pSubsetType - Expand, Level0 for AsIs
##########################################
#  Example Calls:
#  ExecuteProcess('SYSTEM_GenericSubsetCreator', 'pBasis', 'ATTRN', 'pDimension', 'Period', 'pAttrrName', 'MonthNumber', 'pAttrNHighValue',152, 'pAttr
#    NLowValue',141,'pSubName', 'Template Forecast Start Static', 'pOverwrite', 'Yes');
#    Creates period subset betweent Feb09 and Jan10
#Updates:
#Feb 2 2010 - JPorter: Added ability to create subsets by level as well as attribute
#Feb 2 2010 - JPorter: Added ability to add single leaf element to a subset
#Feb 3 2010 - JPorter: Added specific 'PARENT' type subset creation.  this includes new parameter 'pSubsetType' which
# can be set either to 'Expand', or 'Level0'.  If level 0, only level 0 elements below the parent are included.  If 'Expand', all
# elements below the parent are included.
##########################################


IF(SubsetExists(pDimension, pSubName) = 0);
  SubsetCreate(pDimension, pSubName);
ENDIF;

IF(pOverwrite @= 'Yes');
  SubsetDeleteAllElements(pDimension, pSubName);
ENDIF;

IF(pBasis @= 'ATTRS');
  nElemCnt = 1;

  WHILE(nElemCnt <= DIMSIZ(pDimension) );
    vElem = DIMNM(pDimension, nElemCnt);

    IF(pSubsetType @= 'AsIs');
      IF(pParent @<>'' & pAttrName @='');

        SubsetElementInsert( pDimension, pSubName, vElem, SubsetGetSize( pDimension, pSubName)+1);

      ELSEIF( pParent @<>'' & pAttrName @<>'');

        IF(ELISANC( pDimension, pParent, vElem) =1 & ATTRS(pDimension, vElem, pAttrName) @= pAttrSValue);
          SubsetElementInsert( pDimension, pSubName, vElem, SubsetGetSize( pDimension, pSubName)+1);
        ENDIF;

      ELSEIF( pParent @='' & pAttrName @<>'');

        IF(ATTRS(pDimension, vElem, pAttrName) @= pAttrSValue);
          SubsetElementInsert( pDimension, pSubName, vElem, SubsetGetSize( pDimension, pSubName)+1);
        ENDIF;

      ENDIF;

    ELSE;
      IF(pParent @<>'' & pAttrName @='');

        IF(ELISANC( pDimension, pParent, vElem) =1& ELLEV(pDimension,vElem)=0);
          SubsetElementInsert( pDimension, pSubName, vElem, SubsetGetSize( pDimension, pSubName)+1);
        ENDIF;

      ELSEIF( pParent @<>'' & pAttrName @<>'');

        IF(ELISANC( pDimension, pParent, vElem) =1 & ATTRS(pDimension, vElem, pAttrName) @= pAttrSValue & ELLEV(pDimension,vElem)=0);
          SubsetElementInsert( pDimension, pSubName, vElem, SubsetGetSize( pDimension, pSubName)+1);
        ENDIF;

      ELSEIF( pParent @='' & pAttrName @<>'');

        IF(ATTRS(pDimension, vElem, pAttrName) @= pAttrSValue & ELLEV(pDimension,vElem)=0);
          SubsetElementInsert( pDimension, pSubName, vElem, SubsetGetSize( pDimension, pSubName)+1);
        ENDIF;

      ENDIF;
    ENDIF;
    nElemCnt = nElemCnt +1;
  END;

ELSEIF(pBasis @= 'ATTRN');
  nElemCnt = 1;

  WHILE(nElemCnt <= DIMSIZ(pDimension) );
    vElem = DIMNM(pDimension, nElemCnt);

    IF(pParent @<>'' & pAttrName @='');

      IF(ELLEV(pDimension, pParent) > 0);
        IF(ELISANC( pDimension, pParent, vElem) =1& ELLEV(pDimension,vElem)=0);
          SubsetElementInsert( pDimension, pSubName, vElem, SubsetGetSize( pDimension, pSubName)+1);
        ENDIF;
      ELSEIF(ELLEV(pDimension, pParent) = 0);
        IF(vElem @= pParent);
          SubsetElementInsert( pDimension, pSubName, vElem, SubsetGetSize( pDimension, pSubName)+1);
        ENDIF;
      ENDIF;

    ELSEIF( pParent @<>'' & pAttrName @<>'');

      IF(ELLEV(pDimension, pParent) > 0);
        IF(ELISANC( pDimension, pParent, vElem) =1
          & ATTRN(pDimension, vElem, pAttrName) >= pAttrNLowValue
          & ATTRN(pDimension, vElem, pAttrName) <= pAttrNHighValue & ELLEV(pDimension,vElem)=0);
          SubsetElementInsert( pDimension, pSubName, vElem, SubsetGetSize( pDimension, pSubName)+1);
        ENDIF;
      ELSEIF(ELLEV(pDimension, pParent) = 0);
        IF(vElem @= pParent
          & ATTRN(pDimension, vElem, pAttrName) >= pAttrNLowValue
          & ATTRN(pDimension, vElem, pAttrName) <= pAttrNHighValue & ELLEV(pDimension,vElem)=0);
          SubsetElementInsert( pDimension, pSubName, vElem, SubsetGetSize( pDimension, pSubName)+1);
        ENDIF;
      ENDIF;

    ELSEIF( pParent @='' & pAttrName @<>'');

      IF(ATTRN(pDimension, vElem, pAttrName) >= pAttrNLowValue
        & ATTRN(pDimension, vElem, pAttrName) <= pAttrNHighValue
        & ELLEV(pDimension,vElem)=0);
        SubsetElementInsert( pDimension, pSubName, vElem, SubsetGetSize( pDimension, pSubName)+1);
      ENDIF;

    ENDIF;

    nElemCnt = nElemCnt +1;
  END;

ELSEIF(pBasis @= 'LEVEL');
  nElemCnt = 1;
  IF(ELLEV(pDimension, pParent) = pLevel & pParent @<> '');
    SubsetElementInsert( pDimension, pSubName, pParent, SubsetGetSize( pDimension, pSubName)+1);
  ELSE;

  WHILE(nElemCnt <= DIMSIZ(pDimension) );
    vElem = DIMNM(pDimension, nElemCnt);

    IF(pParent @<>'' );

      IF(ELISANC( pDimension, pParent, vElem) =1& ELLEV(pDimension,vElem)=pLevel);
        SubsetElementInsert( pDimension, pSubName, vElem, SubsetGetSize( pDimension, pSubName)+1);
      ENDIF;

    ELSEIF( pParent @='' );

      IF(ELLEV(pDimension,vElem)=pLevel & pSubsetType @<> 'Expand' );
        SubsetElementInsert( pDimension, pSubName, vElem, SubsetGetSize( pDimension, pSubName)+1);
      ENDIF;

##
      IF(ELLEV(pDimension,vElem)<=pLevel & pSubsetType @= 'Expand');
        SubsetElementInsert( pDimension, pSubName, vElem, SubsetGetSize( pDimension, pSubName)+1);
      ENDIF;
##

    ENDIF;

    nElemCnt = nElemCnt +1;
  END;
  ENDIF;

ELSEIF(pBasis @= 'LEAF');
  SubsetElementInsert( pDimension, pSubName, pElement, SubsetGetSize( pDimension, pSubName)+1);

ELSEIF(pBasis @= 'PARENT');
  nElemCnt = 1;
  IF(pSubsetType @= 'Expand' & pParent @<> '');
    SubsetElementInsert( pDimension, pSubName, pParent, SubsetGetSize (pDimension, pSubName) + 1);
  ENDIF;

  WHILE(nElemCnt <= DIMSIZ(pDimension) );
    vElem = DIMNM(pDimension, nElemCnt);

    IF(pParent @<> '');
      IF(pSubsetType @= 'Level0');
        IF(ELISANC( pDimension, pParent, vElem) =1& ELLEV(pDimension,vElem)=0);
          SubsetElementInsert( pDimension, pSubName, vElem, SubsetGetSize( pDimension, pSubName)+1);
        ENDIF;

      ELSEIF(pSubsetType @= 'Expand');
        IF(ELISANC( pDimension, pParent, vElem) = 1);
          SubsetElementInsert( pDimension, pSubName, vElem, SubSetGetSize (pDimension, pSubName) + 1);
        ENDIF;
      ENDIF;
    ELSE;
      IF(pSubsetType @= 'Level0');
        IF(ELLEV(pDimension,vElem)=0);
          SubsetElementInsert( pDimension, pSubName, vElem, SubsetGetSize( pDimension, pSubName)+1);
        ENDIF;

      ELSEIF(pSubsetType @= 'Expand');
          SubsetElementInsert( pDimension, pSubName, vElem, SubSetGetSize (pDimension, pSubName) + 1);
      ENDIF;
    ENDIF;

  nElemCnt = nElemCnt + 1;
  END;

ENDIF;


IF(pAlias @='Yes');

SubsetAliasSet( pDimension, pSubName, pAliasName );

ENDIF;
573,3

#****Begin: Generated Statements***
#****End: Generated Statements****
574,3

#****Begin: Generated Statements***
#****End: Generated Statements****
575,3

#****Begin: Generated Statements***
#****End: Generated Statements****
576,CubeAction=1511DataAction=1503CubeLogChanges=0
930,0
638,1
804,0
1217,0
900,
901,
902,
903,
906,
929,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,0
918,0
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
